function [ n, k , d_interl, d_min, rate, Generator, BCH_Code, BCH_Code_Symbols ]  = BCH( n, k, d_interl )
%this function generates the parameters:
%
%  n: codeword block length
%  k: information block length
%  d_interl: interleaving depth
%  
% OUTPUT: Generator matrix + Codebook + {+1/-1} Codebook
%
%load the BCH code
load Code_v2;
BCH_Code = Code;

%Codebook with \{ +/- 1 \}
BCH_Code_Symbols = 2*Code - 1;

%rate of the code
rate = k/(n);


%polynomial g(x)
g =  bchgenpoly(n,k);
%generator in ascending order
g = g(end : -1 : 1);


%convert to matlab array form
g = (g==1); 


 


%construct the generator poly for concatenated code
g_new = zeros(1,(d_interl)*(length(g)-1)+1);
%construct the polynomial g(x^interl)
g_new(1:d_interl:end) = g;

%construct the generator matrix of interleraved BCH code
Generator = ConstructBCHGenerator( g_new, n*d_interl, k*d_interl  );

%minimum distance of the code
 d_min = min(sum(BCH_Code(2:end,:),2));
end

